import Flutter
import UIKit
import ZaloSDK

public class SwiftZaloSignInPlugin: NSObject, FlutterPlugin {
    
    var parentController : UIViewController?
    
    init(viewController : UIViewController?) {
        parentController = viewController
    }
    
    //    override  func application(_ application: UIApplication, open url: URL, sourceApplication: String, annotation: Any) -> Bool {
    //        print(url)
    //        return ZDKApplicationDelegate.sharedInstance().application(application, open: url, sourceApplication: sourceApplication, annotation: annotation)    }
    //
    public static func register(with registrar: FlutterPluginRegistrar) {
        
        let channel = FlutterMethodChannel(name: "com.yd.zalo/zalo_sign_in", binaryMessenger: registrar.messenger())
        
        let viewController = UIApplication.shared.delegate?.window??.rootViewController
        
        let instance = SwiftZaloSignInPlugin(viewController: viewController)
        
        registrar.addMethodCallDelegate(instance, channel: channel)
    }
    
    public func handle(_ call: FlutterMethodCall, result: @escaping FlutterResult) {
        
        print("iam handle at: ")
        print(self.parentController.debugDescription)
        
        print("iam handle")
        
        switch call.method {
            
        case "logIn":
            login(result: result)
            break
            
        default:
            result(FlutterMethodNotImplemented)
        }
    }
    
    func login(result: @escaping FlutterResult) {
        
        print("iam login")
        
        //ZaloSDK.sharedInstance()?.initialize(withAppId: "261102462094247253")
        
        //        ZaloSDK.sharedInstance()?.authenticateZalo(with: ZAZAloSDKAuthenTypeViaZaloAppAndWebView , parentController: self.parentController, handler: { (response) in
        //            print("iam authenticateZalo")
        //            self.onAuthenticateComplete(with: response, result: result)
        //        })
        
        ZaloSDK.sharedInstance().authenticateZalo(with: ZAZAloSDKAuthenTypeViaZaloAppAndWebView, parentController:  self.parentController) { (response) in
            print("iam authenticateZalo")
            self.onAuthenticateComplete(with: response, result: result)
        }
    }
    
    
    func onAuthenticateComplete(with response: ZOOauthResponseObject?, result: @escaping FlutterResult) {
        
        print("iam onAuthenticateComplete")
        
        if(response == nil || response?.isSucess == false) {
            result(self.getErrorResult(with: response))
        } else {
            result(self.getSuccesResult(with: response!))
        }
    }
    
    func getSuccesResult(with response: ZOOauthResponseObject) -> [String : Any]{
        return [
            "isSuccess" : true,
            "errorCode" : 0,
            "code" : response.oauthCode
        ]
    }
    
    func getErrorResult(with response: ZOOauthResponseObject?) -> [String : Any]{
        return [
            "isSuccess" : false,
            "errorCode" : response?.errorCode ?? -1001,
            "message" : response?.errorMessage ?? "Null ZOOauthResponseObject from native code(-1001)"
        ]
    }
}
